"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setUtm = exports.setSessionId = exports.setClientId = exports.deleteUtm = exports.UTM_KEY = exports.SESSION_ID_KEY = exports.CLIENT_ID_KEY = void 0;
var _session = require("nebenan-redux-tools/lib/session");
const {
  setSession
} = _session.actions;
const UTM_KEY = exports.UTM_KEY = 'utm';
const CLIENT_ID_KEY = exports.CLIENT_ID_KEY = 'analyticsClientId';
const SESSION_ID_KEY = exports.SESSION_ID_KEY = 'analyticsSessionId';
const setUtm = keys => setSession({
  [UTM_KEY]: {
    keys,
    timestamp: Date.now()
  }
});
exports.setUtm = setUtm;
const deleteUtm = () => setSession({
  [UTM_KEY]: undefined
});
exports.deleteUtm = deleteUtm;
const setClientId = id => setSession({
  [CLIENT_ID_KEY]: {
    id,
    timestamp: Date.now()
  }
});
exports.setClientId = setClientId;
const setSessionId = id => setSession({
  [SESSION_ID_KEY]: {
    id,
    timestamp: Date.now()
  }
});
exports.setSessionId = setSessionId;